docs / init script

This commit is contained in:
Patrick Stadler 2015-03-17 21:01:01 +01:00
parent 639812ea2b
commit a9fc6778ac
2 changed files with 65 additions and 130 deletions

View File

@ -1,6 +1,8 @@
# metrics.sh # metrics.sh
metrics.sh is a metrics collection and fowarding daemon implemented in portable shell scripts. A simple interface based on hooks allows for writing custom metrics collectors. metrics.sh is a lightweight metrics collection and fowarding utility implemented in portable POSIX compliant shell scripts. An elegant interface based on hooks enables writing custom metric collectors and forwarders in a transparent way.
Besides having a low impact on system resources, which makes metric.sh a suitable solution for running in virtual environments and servers with limited capacities, simplicty is the main goal of this project, hence its documentation shall fit in a single README.
## Usage ## Usage

View File

@ -1,157 +1,90 @@
#! /bin/sh #!/bin/sh
### BEGIN INIT INFO ### BEGIN INIT INFO
# Provides: metrics.sh # Provides: metrics.sh
# Required-Start: $remote_fs $syslog # Required-Start: $local_fs $network $named $time $syslog
# Required-Stop: $remote_fs $syslog # Required-Stop: $local_fs $network $named $time $syslog
# Should-Start: $network
# Should-Stop: $network
# Default-Start: 2 3 4 5 # Default-Start: 2 3 4 5
# Default-Stop: 0 1 6 # Default-Stop: 0 1 6
# Short-Description: Start and stop metrics.sh # Short-Description: Start and stop metrics.sh
# Description: Controls the metrics daemon "metrics.sh" # Description: Controls the metrics daemon "metrics.sh"
### END INIT INFO ### END INIT INFO
# Author: Patrick Stadler <patrick.stadler@gmail.com SCRIPT=<SCRIPT>
RUNAS=<USER>
# Do NOT "set -e" ARGS=<ARGS>
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Collect and report system metrics"
NAME=metrics.sh NAME=metrics.sh
DAEMON=/usr/bin/$NAME
DAEMON_ARGS=""
PIDFILE=/var/run/$NAME.pid PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME LOGFILE=/var/log/$NAME.log
# Exit if the package is not installed # Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0 [ -x "$DAEMON" ] || exit 0
# Read configuration variable file if it is present start() {
[ -r /etc/default/$NAME ] && . /etc/default/$NAME if [ -f $PIDFILE ] && kill -0 $(cat $PIDFILE); then
echo 'Service already running' >&2
# Load the VERBOSE setting and other rcS variables return 1
. /lib/init/vars.sh fi
echo 'Starting service…' >&2
# Define LSB log_* functions. local CMD="$SCRIPT &> \"$LOGFILE\" & echo \$!"
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present su -c "$CMD $ARGS" $RUNAS > "$PIDFILE"
# and status_of_proc is working. echo 'Service started' >&2
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
} }
# stop() {
# Function that stops the daemon/service if [ ! -f "$PIDFILE" ] || ! kill -0 $(cat "$PIDFILE"); then
# echo 'Service not running' >&2
do_stop() return 1
{ fi
# Return echo 'Stopping service…' >&2
# 0 if daemon has been stopped kill -15 $(cat "$PIDFILE") && rm -f "$PIDFILE"
# 1 if daemon was already stopped echo 'Service stopped' >&2
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
} }
# status() {
# Function that sends a SIGHUP to the daemon/service printf "%-50s" "Checking $NAME..."
# if [ -f $PIDFILE ]; then
do_reload() { PID=$(cat $PIDFILE)
# if [ -z "$(ps axf | grep ${PID} | grep -v grep)" ]; then
# If the daemon can reload its configuration without printf "%s\n" "The process appears to be dead but pidfile still exists"
# restarting (for example, when it is sent a SIGHUP), else
# then implement that here. echo "Running, the PID is $PID"
# fi
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME else
return 0 printf "%s\n" "Service not running"
fi
}
uninstall() {
echo -n 'Are you really sure you want to uninstall this service? That cannot be undone. [yes|No] '
local SURE
read SURE
if [ "$SURE" = "yes" ]; then
stop
rm -f "$PIDFILE"
echo "Notice: log file was not removed: '$LOGFILE'" >&2
update-rc.d -f <NAME> remove
rm -fv "$0"
fi
} }
case "$1" in case "$1" in
start) start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME" start
do_start ;;
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop) stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" stop
do_stop ;;
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
status) status)
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $? status
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;; ;;
*) uninstall)
# Failed to stop uninstall
log_end_msg 1 ;;
restart)
stop
start
;; ;;
esac
;;
*) *)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2 echo "Usage: $0 {start|stop|status|restart|uninstall}"
echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
exit 3
;;
esac esac
: